{.po0}
{.pl71}
function getid(prompt: line): integer;

  var
    temp: person;

  begin
    temp := allcaps(getinput(prompt, 28, echo));
    if temp = '' then getid := 0 else getid := findid(temp);
  end;

function getname(usernbr: integer): person;

  var
    tempid: sysid;

  begin
   if filesize(idfile) > 0 then
    begin
      seek(idfile, usernbr-1);
      read(idfile, tempid);
      getname := tempid.user
    end
   else
      getname := caller
  end;

procedure listsections;

  var
    loopvar : integer;
    temp    : line;

  begin
    if cts then begin
      clearsc;
      lineout('Osastot:' + cr + lf);
      for loopvar := 1 to numsects do begin
        lineout(sect[loopvar]);
      end;
    end;
  end;

  procedure storebuff(var buffernum: byte; var paused, aborted: boolean);

    var loop: byte;

    begin
      loop := 0;
      while (loop < buffernum) and not aborted do begin
        blockwrite(datafile, filebuff[loop], 1);
        if IOresult > 0 then aborted := true;
        loop := loop + 1;
      end;
      if buffernum in [1..16] then filebuff[0] := filebuff[buffernum];
      buffernum := 0;
      repeat xmit(17) until timedin;
      paused := false;
    end;

  procedure textcap(var successful: boolean);

    var
      buffernum, where, loop  : byte;
      cc, cz, paused          : boolean;
      withecho, done, aborted : boolean;
      temp                    : byte;

    begin
      withecho := (getcap('Haluatko tekstin kaiutetuksi (K/E) ? ') = 'K');
      lineout('Aloitan "imem{{n" teksti{: 2 CTRL-C:t{ peruuttaa' +
              ' 2 CTRL-Z:aa lopettaa. ');
      cc := false;
      cz := false;
      done := false;
      paused := false;
      buffernum := 0;
      where := 0;
      rewrite(datafile);
      aborted := (IOresult > 0);
      while cts and not (done or aborted) do begin
        if paused then
          if not timedin then storebuff(buffernum, paused, aborted);
        temp := inbyte;
        if not cts then aborted := true;
        if withecho and outready then xmit(temp);
        if temp = 3 then begin if cc then aborted := true else cc := true; end
          else cc := false;
        if temp = 26 then begin if cz then done := true else cz := true; end
          else cz := false;
        filebuff[buffernum][where] := temp;
        where := where + 1;
        if where > 127 then begin
          where := 0;
          buffernum := buffernum + 1;
        end;
        if buffernum > 14 then begin
          xmit(19);
          paused := true;
        end;
        if buffernum > 16 then aborted := true;
      end;
      if done and cts and not aborted then begin
        buffernum := buffernum + 1;
        storebuff(buffernum, paused, aborted);
      end;
      close(datafile);
      if aborted and (IOresult = 0) then erase(datafile);
    successful := done and (IOresult=0) and not aborted;
    end;

  function exists(filename: name): boolean;

    var found: boolean;

    begin
      assign(datafile, filename);
      {$I-} reset(datafile) {$I+};
      found := (IOresult = 0);
      if found then close(datafile);
      exists := found;
    end;

  function alpha(filename: name): boolean;

    var strpos: integer;
        okay:   boolean;
        dots:   byte;

    begin
      dots := 0;
      alpha := true;
      if length(filename) > 0 then
        for strpos := 1 to length(filename) do begin
          if filename[strpos] = '.' then dots := dots + 1;
          if not (filename[strpos] in ['.', '-', '_', '0'..'9', 'A'..'Z'])
            then alpha := false;
        end;
      if dots > 1 then alpha := false;
    end;

  function getlegal: name;

    var filename:  name;
        dotpos: integer;

    begin
      repeat
        filename := allcaps(getinput('Tiedoston nimi : ', 12, echo));
        dotpos := pos('.', filename);
      until ((dotpos < 10) and (dotpos <> 1)
       and (not((dotpos = 0) and (length(filename) > 8)))
       and (not((dotpos > 0) and (length(filename) > dotpos + 3)))
       and alpha(filename))
       or (filename = '');
      getlegal := filename;
    end;

  function dirpos(filename: name): integer;

    var loopvar: integer;

    begin
      dirpos := 0;
      loopvar := 0;
      repeat
        loopvar := loopvar + 1;
      until (filetab[loopvar].title = filename) or (loopvar >= enddir);
    if filetab[loopvar].title = filename then dirpos := loopvar;
    end;

  function getsect: byte;

    var temp: integer;

    begin
      if sectsin then repeat
        temp := getint(numsects, 0, 'Mik{ osasto (0=kaikki, ?=menu) : ');
        if temp = -1 then listsections else getsect := temp;
      until (temp <> -1) or not cts
      else getsect := 1;
    end;

  procedure addfile(filename: name; sectnum: byte; xmodem: boolean);

    begin
      with filetab[enddir + 1] do begin
        title := filename;
        submit := usernum;
        date := timeon;
        assign(datafile, filedrive + filename);
        reset(datafile);
        size := filesize(datafile);
        close(datafile);
        accesses := 0;
        ASCII := not xmodem;
        section := sectnum;
        public := false;
      end;
    end;

  procedure newfile(xmodem: boolean);

    var
      filename: name;
      successful: boolean;
      sectnum: byte;

    begin
      clearsc;
      if enddir >= mostfiles then lineout('Tiedostotila on loppu. ')
      else begin
        stringout('Kopiointi t{nne: ');
        filename := getlegal;
        if filename <> '' then begin
          if exists(filedrive + filename) then
            lineout('Tiedostonimi on k{yt|ss{. ')
          else begin
            repeat sectnum := getsect until (sectnum <> 0) or not cts;
            assign(datafile, filedrive + filename);
            if cts then begin
              if xmodem then upload(successful)
                else textcap(successful);
              if successful then addfile(filename, sectnum, xmodem);
              clearline;
              if successful then enddir := enddir + 1
                else lineout('Virhe siirrossa tai levy t{ynn{... ');
            end;
          end;
        end;
      end;
    end;

  function legaltab(prompt: line): integer;

    var filename: name;
        tabloc:   integer;

    begin
      tabloc := 0;
      clearsc;
      stringout(prompt);
      filename := getlegal;
      if filename <> '' then
       begin
        tabloc := dirpos(filename);
        if tabloc <> 0 then
          if not (filetab[tabloc].public or (access > reg)) then tabloc := 0;
        if tabloc <> 0 then assign(datafile, filedrive + filename)
          else if filename <> '' then lineout('Tiedostoa ei l|ydy. ');
       end;
      legaltab := tabloc;
    end;

  procedure transmitfile;

    var
      successful: boolean;
      tabloc: integer;

    begin
      tabloc := legaltab('Kopiointi t{{lt{: ');
      if tabloc > 0 then begin
        download(successful);
        if successful then with filetab[tabloc] do
          accesses := accesses + 1
        else lineout('Siirto ep{onnistui. ');
      end;
    end;

  procedure textdump;
    var
      tabloc : integer;
      libname: longname;
    begin
      tabloc := legaltab('ASCII-tekstin tulostus BBS:st{: ');
      lineout(space);
      if tabloc > 0 then with filetab[ tabloc ] do begin
        libname := title;
        if pos('.LBR', title) > 1 then begin
          lineout(title + ' kirjasto valittu. Valitse nyt j{sen : ');
          libname := getlegal;
          if libname = '' then libname := 'DIR';
          libname := copy(title, 1, length(title)-4) + '/' + libname;
        end;
        typefile(filedrive + libname, false);
        if not cancelled then accesses := accesses + 1;
      end;
    end;

  procedure showspace;

    var  loop, howbig, howmuch, sectmin : integer;
         temp : line;

    begin
      sectmin := ksize * 8; (* 16 sektorin BLOCK SHIFT = 2 kilotavua. *)
      howmuch := drivecap;
      if enddir > 0 then for loop := 1 to enddir do
       with filetab[ loop ] do begin
        IF size > 0 THEN
         howbig := ksize * ((sectmin + size - 1) div sectmin)
        ELSE
         howbig := 0;
        howmuch := howmuch - howbig;
      end;
      str(howmuch:4, temp);
      if cts then lineout(cr + lf + temp + ' kilotavua tilaa j{ljell{.');
    end;

  procedure dir(sectnum: byte);

    var loop, spaces : byte;
        howbig, sectmin : integer;
        any  : boolean;
        temp : line;

    begin
      any := false;
      sectmin := ksize * 8; (* ksize = BLOCK SHIFT = 2 kilotavua. *)
      lineout(space);       (* Vastaa 16 sektoria. *)
      if sectsin then lineout('Osasto ' + sect[ sectnum ] + ': ');
      if enddir > 0 then for loop := 1 to enddir do
       with filetab[ loop ] do
       begin
        if size > 0 THEN
         howbig := ksize * (( sectmin + size - 1) div sectmin)
        ELSE
         howbig := 0;
        if cts and (public or (access = sysop) or (submit = usernum))
         and (sectnum = section) then
         begin
          str(howbig:4, temp);
          for spaces := length(title) to 13 do temp := space + temp;
          temp := title + temp + ' kilotavua';
          for spaces := length(temp) + 1 to 30 do temp := temp + space;
          stringout(temp);
          stringout(date);
          if not public then
           lineout(' ==> YKSITYINEN <== ')
          else
           lineout(space);
          if (access = sysop) or (submit = usernum) then
           begin
            str(accesses:4, temp);
            temp := 'Lukukertoja:  ' + temp;
            for spaces := Length(temp) + 1 to 30 do temp := temp + space;
            stringout(temp);
            lineout('L{hett{j{: ' + getname(submit));
           end;
          any := true;
        end;
      end;
      if cts and not any then lineout('Ei tiedostoja. ');
    end;

  procedure directory;

    var sectnum : byte;

    begin
      stringout('Hakemisto: ');
      sectnum := getsect;
      if sectnum > 0 then dir(sectnum)
        else for sectnum := 1 to numsects do dir(sectnum);
      showspace;
    end;

  procedure ldir;

    var
      tabloc : integer;

    begin
      tabloc := legaltab('Kirjaston hakemisto. ');
      lineout(space);
      if tabloc > 0 then typefile(filedrive + filetab[tabloc].title + '/DIR',
                                  false);
    end;

  procedure killfile;

    var loop, tabloc: integer;

    begin
      tabloc := legaltab('Tiedoston tuhoaminen. ');
      if tabloc > 0 then begin
        erase(datafile);
        if enddir > tabloc then for loop := tabloc + 1 to enddir do
          filetab[loop - 1] := filetab[loop];
        enddir := enddir - 1;
      end;
    end;

  procedure installfile;

    var filename : name;
        sectnum  : byte;

    begin
      if enddir < mostfiles then begin
        filename := getlegal;
        if filename <> '' then begin
          if exists(filedrive+filename) and (dirpos(filename) = 0) then begin
            repeat sectnum := getsect until (sectnum <> 0) or not cts;
            addfile(filename, sectnum, true);
            enddir := enddir + 1;
            lineout('Tiedosto installoitu. ');
          end;
        end;
      end;
    end;

  function newname(tabloc: integer): name;

    var filename: name;

    begin
      newname := filetab[tabloc].title;
      stringout('Uusi nimi : ');
      filename := getlegal;
      if (filename <> '') then begin
        if not exists(filedrive + filename) then begin
          assign(datafile, filedrive + filetab[tabloc].title);
          rename(datafile, filename);
          newname := filename;
          stringout('Tiedosto nimetty.');
        end
        else lineout('VIRHE: nimi on jo k{yt|ss{. ');
      end;
    end;

  procedure editheader;

    var tabloc: integer;
        filename: name;
        innum: integer;
        sectstring: name;

    begin
      tabloc := legaltab('Otsikon muotoilu: ');
      if tabloc > 0 then with filetab[tabloc] do begin
        repeat
          str(section:3, sectstring);
          lineout(space);
          lineout('1- Nimi    : ' + title);
          lineout('2- Kenelt{ : ' + getname(submit));
          lineout('3- Osasto  : ' + sectstring);
          lineout('4- Yleinen : ' + yn[ public ]);
          lineout(space);
          innum := getint(4, 0, 'Muutettavan parametrin nro ?  ');
          case innum of
            1: title := newname(tabloc);
            2: submit := getid('L{hett{j{n nimi ? ');
            3: repeat section := getsect until (section <> 0) or not cts;
            4: public := not public;
          end;
        until (innum = 0) or not cts;
        assign(datafile, filedrive + title);
        reset(datafile);
        size := filesize(datafile);
        close(datafile);
      end else lineout('Tiedosto ei ole hakemistossa. ');
    end;

  procedure initfile;

    var
      loopvar: integer;
      temp: name;

    begin
      lineout('Alustan tiedostoj{rjestelm{n... ');
      loopvar := 0;
      assign(filefile, 'FILES.BBS');
      {$I-} reset(filefile) {$I+};
      if IOresult = 0 then begin
        while not eof(filefile) do begin
          loopvar := loopvar + 1;
          read(filefile, filetab[ loopvar ]);
        end;
        close(filefile);
      end;
      enddir := loopvar;
      filesopen := true;
    end;

  procedure closefile;

    var loopvar: integer;

    begin
      rewrite(filefile);
      if enddir > 0 then
        for loopvar := 1 to enddir do write(filefile, filetab[ loopvar ]);
      close(filefile);
      filesopen := false;
    end;
lefile, filetab[ loopvar ]);
      close(filefile);
      filesopen := false;
    end;
